#include <iostream>
#include <algorithm>
#include <stack>

int main() {
  std::string s;
  int k;
  std::cin >> s >> k;
  std::stack<char> st;
  st.push('z');
  int len = s.length();
  for (int i = 0, k1 = k; i < len; i++) {
    while (k1 > 0 && s[i] > st.top()) {
      st.pop();
      k1--;
    }
    st.push(s[i]);
  }
  while ((int)st.size() > len - k + 1) {
    st.pop();
  }
  std::string ans;
  while (st.size() > 1) {
    ans.push_back(st.top());
    st.pop();
  }
  std::reverse(ans.begin(), ans.end());
  std::cout << ans << std::endl;
}